/// <reference types="./alter-table-node.d.ts" />
import { freeze } from '../util/object-utils.js';
import { TableNode } from './table-node.js';
/**
 * @internal
 */
export const AlterTableNode = freeze({
    is(node) {
        return node.kind === 'AlterTableNode';
    },
    create(table) {
        return freeze({
            kind: 'AlterTableNode',
            table: TableNode.create(table),
        });
    },
    cloneWith(node, props) {
        return freeze({
            ...node,
            ...props,
        });
    },
});
